#pragma once
#include <iostream>
#include <tuple>
#include <vector>
#include <unordered_map>
#include <string>
#include <set>
#include <unordered_set>
#include <array>


struct Edge {
	std::pair<int, int> m_node;
	int m_middle_node;
	Edge() = default;
	Edge(int, int);
	Edge operator= (const Edge&);
	bool operator == (const Edge&) const;
	Edge create_edge(int, int);
	void update_middle(int);
	friend std::istream& operator >> (std::istream&, Edge&);
	friend std::ostream& operator << (std::ostream&,const Edge&);
};

struct Node {
	int m_node_id;
	std::array<double, 3> m_coord;
	bool m_vertex = 0;
	Node() = default;
	Node(int, const std::array<double, 3>&, bool);
	Node(const Node&);
	friend std::istream& operator >> (std::istream&, Node&);
	friend std::ostream& operator << (std::ostream&, const Node&);
};

struct FiniteElement {
	int m_element_id;
	int m_material_id;
	std::vector<int> m_node_id;
	FiniteElement() = default;
	FiniteElement(int, int, const std::vector<int>&);
	friend std::istream& operator >> (std::istream&, FiniteElement&);
	friend std::ostream& operator << (std::ostream&, const FiniteElement&);
};

struct BoundaryFiniteElement {
	int m_element_id;
	int m_surface_id;
	std::vector<int> m_node_id;
	BoundaryFiniteElement() = default;
	BoundaryFiniteElement(int, int, const std::vector<int>&);
	friend std::istream& operator >> (std::istream&, BoundaryFiniteElement&);
	friend std::ostream& operator << (std::ostream&, const BoundaryFiniteElement&);
};

