#pragma once
#include "DataType.h"


#pragma region HashCustom
template <typename _T>
inline void hashCombine(std::size_t& a_seed, const _T& c_val) {
	a_seed ^= std::hash<_T>()(c_val) + 0x9e3379b9 + (a_seed << 6) + (a_seed >> 2);
}

template <typename _T>
inline void hashVal(std::size_t& a_seed, const _T& c_val) {
	hashCombine(a_seed, c_val);
}

template <typename _T, typename..._Types>
inline void hashVal(std::size_t& a_seed, const _T& c_val, const _Types& ...p_args) {
	hashCombine(a_seed, c_val);
	hashVal(a_seed, p_args...);
}

template<typename ... _Types>
inline std::size_t hashVal(const _Types& ...p_args) {
	std::size_t seed = 0;
	hashVal(seed, p_args...);
	return seed;
}

namespace std {
	template <> struct hash <Edge> {
		size_t operator() (const Edge& edge) const {
			return hashVal(edge.m_node.first, edge.m_node.second);
		}
	};
}

#pragma endregion