#pragma once
#include "DataType.h"

class MeshLoader
{
public:
	virtual ~MeshLoader() = default;
	virtual void LoadMesh(const std::string&) = 0;
protected:
	std::vector<Node> m_node;
	std::vector<FiniteElement> m_fin_el;
	std::vector<BoundaryFiniteElement> m_bound_fin_el;
public:
	const std::vector<Node>& getNode() const;
	const std::vector<FiniteElement>& getFiniteNode() const;
	const std::vector<BoundaryFiniteElement> getBoundFinNode() const;
	std::vector<int> getElemByID(int node_id1, int node_id2, int node_id3) const;
	std::vector<int> getElemByEdge(int node_id1, int node_id2) const;
	std::vector<int> getElemByMaterial(int material_id) const;
	std::set<int> getNodeBySurface(int surface_id) const;
	std::vector<int> getBoundBySurface(int surface_id) const;
	void insertNode();
	std::vector<std::set<int>> getAdjacentNode() const;
	
private:
	std::array<double, 3> getMidEdge(const Edge&);
	Node getMidNode(const Edge&);
	Node& getNodeByID(int);
	
};

