#include <iostream>
#include <unordered_map>
#include <set>
#include "DataType.h"
#include "aneu_MeshLoader.h"

int main()
{
	MeshLoader* loader = new aneu_MeshLoader;
	loader->LoadMesh("cone.aneu");

	std::vector<Node> nodes = loader->getNode();
	std::vector<FiniteElement> FinElem = loader->getFiniteNode();
	std::vector<BoundaryFiniteElement> Bound = loader->getBoundFinNode();

	std::vector<int> elem_by_ID = loader->getElemByID(1, 2, 3);
	std::vector<int> elem_by_material = loader->getElemByMaterial(1);
	std::vector<int> elem_by_edge = loader->getElemByEdge(1, 2);

	std::set<int> node_by_surface = loader->getNodeBySurface(1);

	std::vector<int> bound_by_surface = loader->getBoundBySurface(2);

	loader->insertNode();
	
	auto Adj_node = loader->getAdjacentNode();
	delete loader;
	return 0;
}